import React, { useState } from 'react';
var YahScroller = function (_a) {
    var className = _a.className, children = _a.children;
    var scrollRef = React.useRef(null);
    var initialPosition = { scrollLeft: 0, x: 0 };
    var _b = useState(false), grab = _b[0], setGrab = _b[1];
    var mouseDown = function (event) {
        var _a, _b;
        if (!grab && scrollRef.current !== null) {
            setGrab(true);
            initialPosition.scrollLeft = (_b = (_a = scrollRef.current) === null || _a === void 0 ? void 0 : _a.scrollLeft) !== null && _b !== void 0 ? _b : 0;
            initialPosition.x = event.clientX;
            window.addEventListener('mousemove', mouseMove);
            window.addEventListener('mouseup', mouseUp);
            window.addEventListener('touchmove', touchMove);
            window.addEventListener('touchend', mouseUp);
        }
    };
    var touchMove = function (event) { return mouseMove(event.touches[0]); };
    var mouseMove = function (event) {
        if (scrollRef.current !== null && scrollRef.current.classList.contains('horizontal-scroll--dragging')) {
            var isStart = scrollRef.current.scrollLeft === 0;
            var isEnd = scrollRef.current.scrollLeft + scrollRef.current.clientWidth === scrollRef.current.scrollWidth;
            var direction = (event.clientX - initialPosition.x) < 0 ? 'right' : 'left';
            if (isStart && direction === 'left')
                scrollRef.current.style.setProperty('--scroll-band', 10 + Math.round((event.clientX - initialPosition.x) / 50) + 'px');
            else if (isEnd && direction === 'right')
                scrollRef.current.style.setProperty('--scroll-band', 10 - Math.round((event.clientX - initialPosition.x) / 50) + 'px');
            else
                scrollRef.current.style.setProperty('--scroll-band', '10px');
            scrollRef.current.scrollLeft = initialPosition.scrollLeft - ((event.clientX - initialPosition.x));
        }
    };
    var mouseUp = function () {
        if (scrollRef.current == null)
            return;
        setGrab(false);
        window.removeEventListener('mousemove', mouseMove);
        window.removeEventListener('mouseup', mouseUp);
        window.removeEventListener('touchmove', touchMove);
        window.removeEventListener('touchend', mouseUp);
        scrollRef.current.style.setProperty('--scroll-band', '10px');
    };
    var touchStart = function (event) { return mouseDown(event.touches[0]); };
    return (React.createElement("div", { ref: scrollRef, onMouseDown: mouseDown, onTouchStart: touchStart, className: "".concat(className, " horizontal-scroll--hide-scrollbars ").concat(grab ? 'horizontal-scroll--dragging' : 'horizontal-scroll--release') }, children));
};
export default YahScroller;
//# sourceMappingURL=YahScroller.js.map